package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.DataAuditDetail;
import com.sa.ibiz.demo.demo.service.DataAuditDetailService;
import com.sa.ibiz.demo.demo.service.dto.DataAuditDetailSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/dataauditdetail")
public class DataAuditDetailResource
{
	@Autowired
	private DataAuditDetailService service;


	@PostMapping(value = "/remove")
	public ResponseEntity<DataAuditDetail> remove(@Validated @RequestBody DataAuditDetail data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("数据审计明细[remove]操作发生错误","DataAuditDetail",data.getDataauditdetailid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<DataAuditDetail> get(@Validated @PathVariable String id){
		DataAuditDetail data=new DataAuditDetail();
		data.setDataauditdetailid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("数据审计明细[get]操作发生错误","DataAuditDetail",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<DataAuditDetail> getDraft(@Validated @RequestBody DataAuditDetail data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("数据审计明细[getDraft]操作发生错误","DataAuditDetail","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<DataAuditDetail> checkKey(@Validated @RequestBody DataAuditDetail data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("数据审计明细[checkKey]操作发生错误","DataAuditDetail",data.getDataauditdetailid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<DataAuditDetail> update(@Validated @RequestBody DataAuditDetail data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("数据审计明细[update]操作发生错误","DataAuditDetail",data.getDataauditdetailid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<DataAuditDetail> create(@Validated @RequestBody DataAuditDetail data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("数据审计明细[create]操作发生错误","DataAuditDetail",data.getDataauditdetailid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<DataAuditDetail>> searchDefaultPage(@Validated @RequestBody DataAuditDetailSearchFilter filter){
		Page<DataAuditDetail> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<DataAuditDetail>> listDefault(@Validated @RequestBody DataAuditDetailSearchFilter filter){
		List<DataAuditDetail> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
